unit DifRov;

interface

const N_max=1000;

type Pole=array[0..N_max] of real;
     Funkcia1=function(x,y:real):real;
     Funkcia2=function(x,y,dy:real):real;

procedure Euler(F:Funkcia1; var P; X0,Y0,h:real; n:integer);
procedure RK2(F:Funkcia1; var P; X0,Y0,h:real; n:integer);
procedure RK4(F:Funkcia1; var P; X0,Y0,h:real; n:integer);
procedure RK42(F:Funkcia2; var P,R; X0,Y0,Z0,h:real; n:integer);

implementation

procedure Euler;
var i:integer; k:real;
begin
     Pole(P)[0]:=Y0;
     for i:=1 to n do begin
         k:=h*f(X0,Y0); X0:=X0+h; Y0:=Y0+k;
         Pole(P)[i]:=Y0
     end
end;

procedure RK2;
var i:integer; k0,k1:real;
begin
     Pole(P)[0]:=Y0;
     for i:=1 to n do begin
         k0:=h*f(X0,Y0);
         k1:=h*f(X0+h/2,Y0+k0/2);
         X0:=X0+h; Y0:=Y0+k1;
         Pole(P)[i]:=Y0
     end
end;

procedure RK4;
var i:integer; k,k0,k1,k2,k3:real;
begin
     Pole(P)[0]:=Y0;
     for i:=1 to n do begin
         k0:=h*f(X0,Y0);
         k1:=h*f(X0+h/2,Y0+k0/2);
         k2:=h*f(X0+h/2,Y0+k1/2);
         k3:=h*f(X0+h,Y0+k2);
         k:=(k0+2*k1+2*k2+k3)/6;
         X0:=X0+h; Y0:=Y0+k;
         Pole(P)[i]:=Y0
     end
end;

procedure RK42;
var k0,k1,k2,k3,g:real; i:integer;
begin
   Pole(P)[0]:=Y0; Pole(R)[0]:=Z0;
   g:=h*h/2;
   for i:=1 to n do
   begin
        k0:=g*f(X0,Y0,Z0);
        k1:=g*f(X0+h/2,Y0+h*Z0/2+k0/4,Z0+k0/h);
        k2:=g*f(X0+h/2,Y0+h*Z0/2+k0/4,Z0+k1/h);
        k3:=g*f(X0+h,Y0+h*Z0+k2,Z0+2*k2/h);
        X0:=X0+h; Y0:=Y0+h*Z0+(k0+k1+k2)/3;
        Z0:=Z0+(k0+2*k1+2*k2+k3)/(3*h);
   Pole(P)[i]:=Y0; Pole(R)[i]:=Z0;
   end
end;

end.
